org.gjt.sp.jedit.textarea

## Class JEditTextArea

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - org.gjt.sp.jedit.textarea.TextArea
        - - org.gjt.sp.jedit.textarea.JEditTextArea

All Implemented Interfaces:
  java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable

    public class JEditTextArea
    extends TextArea

jEdit's text component.

Unlike most other text editors, the selection API permits selection and concurrent manipulation of multiple, non-contiguous regions of text. Methods in this class that deal with selecting text rely upon classes derived the `Selection` class.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JComponent

`javax.swing.JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class java.awt.Container

`java.awt.Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

### Field Summary

Fields
`static java.lang.String` `DEFAULT_FOLD_PAINTER_SERVICE`
`static java.lang.String` `FOLD_PAINTER_PROPERTY` Fold painter service.
`static java.lang.String` `FOLD_PAINTER_SERVICE`

### Fields inherited from class org.gjt.sp.jedit.textarea.TextArea

`buffer, caret, caretLine, ELECTRIC_SCROLL, inputHandlerProvider, multi, NO_SCROLL, NORMAL_SCROLL, painter, popup`

### Fields inherited from class javax.swing.JComponent

`accessibleContext, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`JEditTextArea(View view)` Creates a new JEditTextArea.

### Method Summary

Methods
`void` `addExplicitFold()` Surrounds the selection with explicit fold markers.
`void` `createPopupMenu(java.awt.event.MouseEvent evt)` Creates the popup menu.
`void` `dispose()` Plugins and macros should not call this method.
`protected static void` `doWordCount(View view, java.lang.String text)`
`void` `end(boolean select)` An override to record the acutual action taken for end().
`void` `formatParagraph()` Formats the paragraph containing the caret.
`FoldPainter` `getFoldPainter()`
`static java.lang.String` `getFoldPainterName()`
`View` `getView()` Returns this text area's view.
`void` `goToBufferEnd(boolean select)` Moves the caret to the end of the buffer.
`void` `goToBufferStart(boolean select)` Moves the caret to the beginning of the buffer.
`void` `goToMatchingBracket()` Moves the caret to the bracket matching the one before the caret.
`void` `handlePopupTrigger(java.awt.event.MouseEvent evt)` Do the same thing as right-clicking on the text area.
`void` `handlePropertiesChanged(PropertiesChanged msg)`
`void` `home(boolean select)` An override to record the acutual action taken for home().
`int` `replaceSelection(java.lang.String selectedText)` Set the selection, but does not deactivate it, and does not move the caret.
`void` `showGoToLineDialog()` Displays the 'go to line' dialog box, and moves the caret to the specified line number.
`void` `showWordCountDialog()` Displays the 'word count' dialog box.
`void` `smartEnd(boolean select)` An override to record the acutual action taken for smartHome().
`void` `smartHome(boolean select)` An override to record the acutual action taken for smartHome().
`void` `userInput(char ch)` Handles the insertion of the specified character.

### Methods inherited from class org.gjt.sp.jedit.textarea.TextArea

`addActionSet, addCaretListener, addExplicitFold, addLeftOfScrollBar, addNotify, addScrollListener, addStatusListener, addStructureMatcher, addTopComponent, addToSelection, addToSelection, backspace, backspaceWord, backspaceWord, backspaceWord, blinkCaret, caretAutoScroll, centerCaret, collapseFold, collapseFold, delete, deleteLine, deleteParagraph, deleteToEndOfLine, deleteToStartOfLine, deleteWord, deleteWord, doWordWrap, expandFold, extendSelection, extendSelection, getActionContext, getBuffer, getBufferLength, getCaretLine, getCaretPosition, getDisplayManager, getElectricScroll, getFirstLine, getFirstPhysicalLine, getFocusCycleRoot, getFocusTraversalKeysEnabled, getGutter, getHorizontalOffset, getInputHandler, getInputMethodRequests, getJoinNonWordChars, getLastPhysicalLine, getLastScreenLine, getLineCount, getLineEndOffset, getLineLength, getLineOfOffset, getLineStartOffset, getLineText, getLineText, getMagicCaretPosition, getMarkPosition, getPainter, getPhysicalLineOfScreenLine, getRightClickPopup, getScreenLineEndOffset, getScreenLineOfOffset, getScreenLineStartOffset, getSelectedLines, getSelectedText, getSelectedText, getSelectedText, getSelection, getSelection, getSelectionAtOffset, getSelectionCount, getSelectionIterator, getStructureMatch, getTabExpander, getText, getText, getText, getVisibleLines, getVisibleLineSegment, getVisibleLineText, getVisibleLineText, goToEndOfCode, goToEndOfLine, goToEndOfWhiteSpace, goToFirstVisibleLine, goToLastVisibleLine, goToNextBracket, goToNextCharacter, goToNextFold, goToNextLine, goToNextPage, goToNextParagraph, goToNextWord, goToNextWord, goToParentFold, goToPrevBracket, goToPrevCharacter, goToPrevFold, goToPrevLine, goToPrevPage, goToPrevParagraph, goToPrevWord, goToPrevWord, goToPrevWord, goToStartOfLine, goToStartOfWhiteSpace, indentSelectedLines, initInputHandler, insert, insertEnterAndIndent, insertTabAndIndent, invalidateLine, invalidateLineRange, invalidateScreenLineRange, invertSelection, isCaretBlinkEnabled, isCaretVisible, isCtrlForRectangularSelection, isDragEnabled, isEditable, isMultipleSelectionEnabled, isOverwriteEnabled, isQuickCopyEnabled, isRectangularSelectionEnabled, isRightClickPopupEnabled, joinLines, lineComment, lineInStructureScope, moveCaretPosition, moveCaretPosition, moveCaretPosition, narrowToFold, narrowToSelection, offsetToXY, offsetToXY, offsetToXY, processKeyEvent, propertiesChanged, rangeComment, removeCaretListener, removeFromSelection, removeFromSelection, removeLeftOfScrollBar, removeNotify, removeScrollListener, removeStatusListener, removeStructureMatcher, removeTopComponent, removeTrailingWhiteSpace, resizeSelection, scrollAndCenterCaret, scrollDownLine, scrollDownPage, scrollTo, scrollTo, scrollToCaret, scrollUpLine, scrollUpPage, selectAll, selectBlock, selectFold, selectFold, selectLine, selectNone, selectParagraph, selectToMatchingBracket, selectToMatchingBracket, selectWord, setBuffer, setCaretBlinkEnabled, setCaretPosition, setCaretPosition, setCtrlForRectangularSelection, setDragEnabled, setElectricScroll, setFirstLine, setFirstPhysicalLine, setFirstPhysicalLine, setHorizontalOffset, setJoinNonWordChars, setMagicCaretPosition, setMouseHandler, setMultipleSelectionEnabled, setOverwriteEnabled, setQuickCopyEnabled, setRectangularSelectionEnabled, setRightClickPopup, setRightClickPopupEnabled, setSelectedText, setSelectedText, setSelectedText, setSelection, setSelection, setText, setTransferHandler, shiftIndentLeft, shiftIndentRight, showPopupMenu, showPopupMenu, spacesToTabs, tabsToSpaces, toggleMultipleSelectionEnabled, toggleOverwriteEnabled, toggleRectangularSelectionEnabled, toLowerCase, toString, toUpperCase, turnOnElasticTabstops, userInputTab, xToScreenLineOffset, xyToOffset, xyToOffset`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### FOLD_PAINTER_PROPERTY

    public static final java.lang.String FOLD_PAINTER_PROPERTY

Fold painter service.

Since:
  jEdit 4.3pre16
See Also:
  Constant Field Values

#### FOLD_PAINTER_SERVICE

    public static final java.lang.String FOLD_PAINTER_SERVICE

See Also:
  Constant Field Values

#### DEFAULT_FOLD_PAINTER_SERVICE

    public static final java.lang.String DEFAULT_FOLD_PAINTER_SERVICE

See Also:
  Constant Field Values

### Constructor Detail

#### JEditTextArea

    public JEditTextArea(View view)

Creates a new JEditTextArea.

### Method Detail

#### dispose

    public void dispose()

Description copied from class: `TextArea`
Plugins and macros should not call this method.

Overrides:
  `dispose` in class `TextArea`

#### getFoldPainter

    public FoldPainter getFoldPainter()

Overrides:
  `getFoldPainter` in class `TextArea`

#### home

    public void home(boolean select)

An override to record the acutual action taken for home().

Overrides:
  `home` in class `TextArea`
Parameters:
  `select` - true if we also want to select from the cursor

#### end

    public void end(boolean select)

An override to record the acutual action taken for end().

Overrides:
  `end` in class `TextArea`
Parameters:
  `select` - true if we also want to select from the cursor

#### smartHome

    public void smartHome(boolean select)

An override to record the acutual action taken for smartHome().

Overrides:
  `smartHome` in class `TextArea`
Parameters:
  `select` - true if you want to extend selection

#### smartEnd

    public void smartEnd(boolean select)

An override to record the acutual action taken for smartHome().

Overrides:
  `smartEnd` in class `TextArea`
Parameters:
  `select` - true if you want to extend selection

#### goToBufferEnd

    public void goToBufferEnd(boolean select)

Description copied from class: `TextArea`
Moves the caret to the end of the buffer.

Overrides:
  `goToBufferEnd` in class `TextArea`
Parameters:
  `select` - true if you want to extend selection

#### goToMatchingBracket

    public void goToMatchingBracket()

Moves the caret to the bracket matching the one before the caret. Also sends PositionChanging if it goes somewhere.

Overrides:
  `goToMatchingBracket` in class `TextArea`
Since:
  jEdit 4.3pre18

#### goToBufferStart

    public void goToBufferStart(boolean select)

Description copied from class: `TextArea`
Moves the caret to the beginning of the buffer.

Overrides:
  `goToBufferStart` in class `TextArea`
Parameters:
  `select` - true if you want to extend selection

#### replaceSelection

    public int replaceSelection(java.lang.String selectedText)

Description copied from class: `TextArea`
Set the selection, but does not deactivate it, and does not move the caret. Please use `TextArea.setSelectedText(String)` instead.

Overrides:
  `replaceSelection` in class `TextArea`
Parameters:
  `selectedText` - The new selection
Returns:
  The new caret position

#### showGoToLineDialog

    public void showGoToLineDialog()

Displays the 'go to line' dialog box, and moves the caret to the specified line number.

Since:
  jEdit 2.7pre2

#### userInput

    public void userInput(char ch)

Handles the insertion of the specified character. It performs the following operations in addition to TextArea#userInput(char):

- Inserting a space with automatic abbrev expansion enabled will try to expand the abbrev

Overrides:
  `userInput` in class `TextArea`
Parameters:
  `ch` - The character
Since:
  jEdit 2.7pre3
See Also:
  `TextArea.setSelectedText(String)`, `TextArea.isOverwriteEnabled()`

#### addExplicitFold

    public void addExplicitFold()

Surrounds the selection with explicit fold markers.

Overrides:
  `addExplicitFold` in class `TextArea`
Since:
  jEdit 4.0pre3

#### formatParagraph

    public void formatParagraph()

Formats the paragraph containing the caret.

Overrides:
  `formatParagraph` in class `TextArea`
Since:
  jEdit 2.7pre2

#### doWordCount

    protected static void doWordCount(View view,
                   java.lang.String text)

#### showWordCountDialog

    public void showWordCountDialog()

Displays the 'word count' dialog box.

Since:
  jEdit 2.7pre2

#### getView

    public View getView()

Returns this text area's view.

Since:
  jEdit 4.2pre5

#### getFoldPainterName

    public static java.lang.String getFoldPainterName()

#### handlePopupTrigger

    public void handlePopupTrigger(java.awt.event.MouseEvent evt)

Do the same thing as right-clicking on the text area. The Gestures plugin uses this API.

Overrides:
  `handlePopupTrigger` in class `TextArea`
Since:
  jEdit 4.2pre13

#### createPopupMenu

    public void createPopupMenu(java.awt.event.MouseEvent evt)

Creates the popup menu.

Overrides:
  `createPopupMenu` in class `TextArea`
Since:
  4.3pre15

#### handlePropertiesChanged

    public void handlePropertiesChanged(PropertiesChanged msg)